--[[
			%%%%%%				%%%%%%%%%%			%%%%%%%%%%%%
		%%%%%%%%%%%%%   	%%%%%%%%%%%%%%%%%%%		   %%%%%%	
	   %%%        %%%%    %%%%%            %%%%%        %%%%
	  %%%%		   %%%    %%%%			    %%%%        %%%%
      %%%%%				  %%%%               %%%		%%%%
	   %%%%%%   		  %%%%							%%%%
		  %%%%%%          %%%%							%%%%
              %%%%%       %%%%         %%%%%%			%%%%
			     %%%%     %%%%%         %%%%%%% 		%%%%
			     %%%%%     %%%%%           %%%%			%%%%
			    %%%%%       %%%%%		  %%%%			%%%%
	 %%%%     %%%%%           %%%%%%%%%%%%%%%          %%%%%%
	  %%%%%%%%%%			   %%%%%%%%%%%%%        %%%%%%%%%%%%

	  SuperGuildInvite 
	  
											Written by
											
			Janniie - Stormreaver EU


]]

-- File global variables --
local DATA_INDEX
local LOGO = "|cffffff00<|r|cff16ABB5SGI|r|cffffff00>|r "
SLASH_SUPERGUILDINVITE1 = '/sgi'
SLASH_SUPERGUILDINVITE2 = '/superguildinvite'
local VERSION_MAJOR = "6.0"
local VERSION_MINOR = ""

local SuperScanInterval = 7
local SuperScanLast = 0
local SuperScanProgress = 1
local whoQueryList 
local whoSent
local ScanInProgress = false
local SGI_QUEUE = {}
local SGI_ANTI_SPAM = {}
local SGI_InviteFrames = {}
local whisperWaiting = false

local ID_REQUEST = "SGI_REQ"
local ID_MASSLOCK = "SGI_MASS"
local ID_LOCK = "SGI_LOCK"
local ID_SHIELD = "I_HAVE_SHIELD"
local ID_VERSION = "SGI_VERSION"
RegisterAddonMessagePrefix(ID_REQUEST)
RegisterAddonMessagePrefix(ID_LOCK)
RegisterAddonMessagePrefix(ID_SHIELD)
RegisterAddonMessagePrefix(ID_MASSLOCK)
RegisterAddonMessagePrefix(ID_VERSION)

local MinimapLoad

local GetTime = GetTime
local strfind = strfind
local strsub = strsub
local tonumber = tonumber
----------------------------
local old = print
local function print(...)
	if not SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_MUTE"] then
		old("|cffffff00<|r|cff16ABB5SGI|r|cffffff00>|r",...)
	end
end

	-- && Format seconds to:    && --
	-- && X hours Y mins Z secs && --
	
local function FormatTime(T)
	local R,S,M,H = ""
	T = floor(T)
	H = floor(T/3600)
	M = floor((T-3600*H)/60)
	S = T-(3600*H + 60*M)
		
	if T <= 0 then
		return "less than 1 second"
	end
		
	if H ~= 0 then
		R =  R..H.." hours "
	end
	if M ~= 0 then
		R = R..M.." minutes "
	end
	if S ~= 0 then
		R = R..S.." seconds"
	end
	
	return R
end

local function CountTable(T)
	local i = 0
	if type(T) ~= "table" then
		return i
	end
	for k,_ in pairs(T) do
		i = i + 1
	end
	return i
end

local function FormatWhisper(msg,name)
	local whisper = msg
	if not name then name = "ExampleName" end
	local guildName,guildLevel = GetGuildInfo(UnitName("Player")),GetGuildLevel()
	if not guildName then guildName = "<InvalidName>" end
	if not guildLevel then guildLevel = "<InvalidLevel>" end
	if strfind(msg,"PLAYER") then
		whisper = strsub(msg,1,strfind(msg,"PLAYER")-1)..name..strsub(msg,strfind(msg,"PLAYER")+6)
	end
	if strfind(whisper,"NAME") then
		whisper = strsub(whisper,1,strfind(whisper,"NAME")-1)..guildName..strsub(whisper,strfind(whisper,"NAME")+4)
	end
	if strfind(whisper,"LEVEL") then
		whisper = strsub(whisper,1,strfind(whisper,"LEVEL")-1)..guildLevel..strsub(whisper,strfind(whisper,"LEVEL")+5)
	end
	return whisper
end

local function GetClassColor(classFileName)
	if classFileName == "DEATHKNIGHT" then
		return "C41F3B" 
	elseif classFileName == "DRUID" then
		return "FF7D0A"
	elseif classFileName == "HUNTER" then
		return "ABD473"
	elseif classFileName == "MAGE" then
		return "69CCF0"
	elseif classFileName == "PALADIN" then
		return "F58CBA"
	elseif classFileName == "PRIEST" then
		return "FFFFFF"
	elseif classFileName == "ROGUE" then
		return "FFF569"
	elseif classFileName == "SHAMAN" then
		return "0070DE"
	elseif classFileName == "WARLOCK" then
		return "9482C9"
	elseif classFileName == "WARRIOR" then
		return "C79C6E"
	else
		return "857C7C"
	end
end

local function SetFramePos(frame)
	if not frame then return end
	local name = frame:GetName()
	if type(SGI_DATA[DATA_INDEX].settings.frames[name]) ~= "table" then
		SGI_DATA[DATA_INDEX].settings.frames[name] = {}
	end
	if name == "SGI_MiniMapButton" then
		SGI_DATA[DATA_INDEX].settings.frames[name][3] = SGI_DATA[DATA_INDEX].settings.frames[name][3] or -58.32
		SGI_DATA[DATA_INDEX].settings.frames[name][4] = SGI_DATA[DATA_INDEX].settings.frames[name][4] or -51.79
	end
	SGI_DATA[DATA_INDEX].settings.frames[name][1] = SGI_DATA[DATA_INDEX].settings.frames[name][1] or "CENTER"
	SGI_DATA[DATA_INDEX].settings.frames[name][2] = SGI_DATA[DATA_INDEX].settings.frames[name][2] or "CENTER"
	SGI_DATA[DATA_INDEX].settings.frames[name][3] = SGI_DATA[DATA_INDEX].settings.frames[name][3] or 0
	SGI_DATA[DATA_INDEX].settings.frames[name][4] = SGI_DATA[DATA_INDEX].settings.frames[name][4] or 0

	if name == "SGI_MiniMapButton" then
		frame:SetPoint(
			SGI_DATA[DATA_INDEX].settings.frames[name][1],
			Minimap,
			SGI_DATA[DATA_INDEX].settings.frames[name][2],
			SGI_DATA[DATA_INDEX].settings.frames[name][3],
			SGI_DATA[DATA_INDEX].settings.frames[name][4]
		)
	else
		frame:SetPoint(
			SGI_DATA[DATA_INDEX].settings.frames[name][1],
			UIParent,
			SGI_DATA[DATA_INDEX].settings.frames[name][2],
			SGI_DATA[DATA_INDEX].settings.frames[name][3],
			SGI_DATA[DATA_INDEX].settings.frames[name][4]
		)
	end
end

local function GetFramePos(frame)
	if not frame then return end
	local name = frame:GetName()
	if type(SGI_DATA[DATA_INDEX].settings.frames[name]) ~= "table" then
		SGI_DATA[DATA_INDEX].settings.frames[name] = {}
	end
	local point,relativeTo,relativePoint,xOfs,yOfs = frame:GetPoint()
	
	SGI_DATA[DATA_INDEX].settings.frames[name][1] = point
	SGI_DATA[DATA_INDEX].settings.frames[name][2] = relativePoint
	SGI_DATA[DATA_INDEX].settings.frames[name][3] = xOfs
	SGI_DATA[DATA_INDEX].settings.frames[name][4] = yOfs
end

local function SendLocks(target)
	local parts = {}
	local piece = "SGI_V"
	local i = 0
	for k,_ in pairs(SGI_DATA.lock) do
		piece = piece..":"..k
		if strlen(piece) > 200 then
			i = i + 1
			parts[i] = piece
			piece = "SGI_V"
		end
	end
	local f = CreateFrame("Frame")
	local t,j = 0,0
	f:SetScript("OnUpdate",function()
		if GetTime() > t then
			for h = 1,5 do
				j = j + 1
				if not parts[j] then
					f:SetScript("OnUpdate",nil)
					return
				end
				SendAddonMessage(ID_MASSLOCK,parts[j],"WHISPER",target)
			end
			t = GetTime() + 2
		end
	end)
end

local function divide(str,div)
	local out = {}
	local i = 0
	while strfind(str,div) do
		i = i + 1
		out[i] = strsub(str,1,strfind(str,div)-1)
		str = strsub(str,strfind(str,div)+1)
	end
	return out
end

local function RecievedLocks(msg)
	local locks = divide(msg,":")
	local new = 0
	for k,_ in pairs(locks) do
		if not SGI_DATA.lock[locks[k]] then
			SGI_DATA.lock[locks[k]] = "MASSSHARED"
			new = new + 1
		end
	end
	return new
end

local function RequestSync()
	SendAddonMessage(ID_REQUEST,"","GUILD")
end
	
-- SuperScan --

local function QueueInvite(name,level,classFile,race,class,found)
	SGI_QUEUE[name] = {
		level = level,
		class = class,
		classFile = classFile,
		race = race,
		found = found,
	}
	GuildShield:IsShielded(name)
end

local function PutOnHold(name,level,classFile,race,class,found)
	SGI_ANTI_SPAM[name] = {
		level = level,
		class = class,
		classFile = classFile,
		race = race,
		found = found,
	}
	GuildShield:IsShielded(name)
end

local function RemoveShielded(player)
	SGI_ANTI_SPAM[player] = nil
	print("|cffffff00Removed |r|cff00A2FF"..player.."|r|cffffff00 because they are shielded.|r")
end

local HoldTimer = CreateFrame("Frame")
local HoldUpdate = 0
HoldTimer:SetScript("OnUpdate",function()
	if HoldUpdate < GetTime() then
		for k,_ in pairs(SGI_ANTI_SPAM) do
			if SGI_ANTI_SPAM[k].found + 4 < GetTime() then
				SGI_QUEUE[k] = SGI_ANTI_SPAM[k]
				SGI_ANTI_SPAM[k] = nil
			end
		end
		HoldUpdate = GetTime() + 0.5
	end
end)

local function SendGuildInvite(self,button)
	local name = self.player
	if not name then name = next(SGI_QUEUE) button = "LeftButton" end
	if not name then return end
	if not SGI_DATA.lock[name] then
		SGI_DATA.lock[name] = "INVITED"
	end
	if button == "LeftButton" then
		if SGI_DATA[DATA_INDEX].settings.dropdown["SGI_WHISPER_MODE"] == 1 then
			--invite
			GuildInvite(name)
		elseif SGI_DATA[DATA_INDEX].settings.dropdown["SGI_WHISPER_MODE"] == 2 and SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_WHISPER"] then
			--invite, whisper
			GuildInvite(name)
			whisperWaiting = true
		elseif SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_WHISPER"] then
			--whisper
			SendChatMessage(FormatWhisper(SGI_DATA[DATA_INDEX].settings.whisper,name),"WHISPER",nil,name)
			--print("Simulated whisper to:",name)
		else
			print("|cffffff00You need to specify the mode in which you wish to invite|r")
		end
		SGI_QUEUE[name] = nil
	else
		SGI_QUEUE[name] = nil
	end
end
local checker = CreateFrame("Frame")
checker.font = checker:CreateFontString(nil,"OVERLAY")
checker.font:SetFont("Fonts\\ARIALN.TTF",14)
local function DisplayLocks()
	print("|cffffff00Locked players are: |r")
	for k,_ in pairs(SGI_DATA.lock) do
		local name = k
		checker.font:SetText(name)
		while checker.font:GetWidth() < 70 do
			name = name.." "
			checker.font:SetText(name)
		end
		print("|cffff8800"..name.."|r|cffffff00 locked by |r|cff00ffff"..SGI_DATA.lock[k].."|r")
	end
end

local function CreateScanQuery(low,high,int,race,class)
	local Levels,i = {},low
	local Classes = {
			"Death Knight",
			"Druid",
			"Hunter",
			"Mage",
			--"Monk",
			"Paladin",
			"Priest",
			"Rogue",
			"Shaman",
			"Warlock",
			"Warrior",
	}
	local Races = {}
	if UnitFactionGroup("player") == "Horde" then
		Races = {
			"Orc",
			"Blood Elf",
			"Undead",
			"Troll",
			"Goblin",
			"Tauren",
			--"Pandaren",
		}
	else
		Races = {
			"Human",
			"Dwarf",
			"Worgen",
			"Draenei",
			"Night Elf",
			"Gnome",
			--"Pandaren",
		}
	end
	while i + int < 85 and i + int < high do
		if i + int >= race and i + int >= class then
			for k,_ in pairs(Races) do
				for j,_ in pairs(Classes) do
					tinsert(Levels,i.."- -"..(i+int-1).." r-"..Races[k].. " c-"..Classes[j])
				end
			end
		elseif i + int >= race then
			for k,_ in pairs(Races) do
				tinsert(Levels,i.."- -"..(i+int-1).." r-"..Races[k])
			end
		elseif i + int >= class then
			for k,_ in pairs(Classes) do
				tinsert(Levels,i.."- -"..(i+int-1).." c-"..Classes[k])
			end
		else
			tinsert(Levels,i.."- -"..(i+int-1))
		end
		i = i + int 
	end
	local top = 85 > high and high or 85
	if top >= race and top >= class then
		for k,_ in pairs(Races) do
			for j,_ in pairs(Classes) do
				tinsert(Levels,i.."- -"..top.." r-"..Races[k].. " c-"..Classes[j])
			end
		end
	elseif top >= race then
		for k,_ in pairs(Races) do
			tinsert(Levels,i.."- -"..top.." r-"..Races[k])
		end
	elseif top >= class then
		for k,_ in pairs(Classes) do
			tinsert(Levels,i.."- -"..top.." c-"..Classes[k])
		end
	else
		tinsert(Levels,i.."- -"..top)
	end
	
	if top == 85 then
		for p = top+1,high do
			if p >= race and p >= class then
				for k,_ in pairs(Races) do
					for j,_ in pairs(Classes) do
						tinsert(Levels,p.." r-"..Races[k].. " c-"..Classes[j])
					end
				end
			elseif p >= race then
				for k,_ in pairs(Races) do
					tinsert(Levels,p.." r-"..Races[k])
				end
			elseif p >= class then
				for k,_ in pairs(Classes) do
					tinsert(Levels,p.." c-"..Classes[k])
				end
			else
				tinsert(Levels,p)
			end
		end
	end

	whoQueryList = Levels
end

local function SuperScan()
	if GetTime() > SuperScanLast + SuperScanInterval then
		if SuperScanProgress == #whoQueryList + 1 then
			SuperScanProgress = 1
			SuperScanLast = GetTime()
			SuperScanFrame.timeT = GetTime()
			-- Some resets here?
		else
			SetWhoToUI(1)
			FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE")
			SendWho(whoQueryList[SuperScanProgress])
			whoSent = true
			SuperScanLast = GetTime()
		end
	end		
end
CreateFrame("Frame","SuperScanFrameTimer")

local function BroadcastVersion()
	SendAddonMessage(ID_VERSION,VERSION_MAJOR,"GUILD")
end


-- Event handlers --
local SGI_EVENTS = {}

function SGI_EVENTS:PLAYER_LOGIN()
	if not DATA_INDEX then
		DATA_INDEX = UnitName("player").." - "..GetRealmName()
	end
	if type(SGI_DATA) ~= "table" then
		SGI_DATA = {}
	end
	if type(SGI_DATA.lock) ~= "table" then
		SGI_DATA.lock = {}
	end
	if type(SGI_DATA[DATA_INDEX]) ~= "table" then
		SGI_DATA[DATA_INDEX] = {}
	end
	if type(SGI_DATA[DATA_INDEX].settings) ~= "table" then
		SGI_DATA[DATA_INDEX].settings = {
			isOn = true,
			mute = false,
			inviteMode = 1,
			frames = {},
			checkboxes = {},
			dropdown = {},
			lowLimit = 1,
			highLimit = 90,
			raceStart = 90,
			classStart = 90,
			interval = 5,
			whisper = "Would you like to join my guild? The please press Accept!",
		}
	end
	if MinimapLoad then
		MinimapLoad()
	end
	GuildShield:Initiate(RemoveShielded)
	BroadcastVersion()
	RequestSync()
	print("|cffffff00Successfully loaded|r")
end

function SGI_EVENTS:WHO_LIST_UPDATE()
	if whoSent then
		whoSent = false
		SuperScanProgress = SuperScanProgress + 1
		--local ETR = ((#whoQueryList - SuperScanProgress + 1) * (SuperScanInterval-3))
		local ETR = (#whoQueryList - SuperScanProgress + 1) * SuperScanInterval
		--print(ETR)
		if SuperScanFrame then
			SuperScanFrame.timeV = ETR
			SuperScanFrame.timeS = GetTime()
		end
		for i = 1, GetNumWhoResults() do
			local name, guild, level, race, class, zone, classFileName = GetWhoInfo(i)
			if guild == "" and not SGI_DATA.lock[name] then
				PutOnHold(name,level,classFileName,race,class,GetTime())
			end
		end
				
	end
end

function SGI_EVENTS:CHAT_MSG_ADDON(event,...)
	local ID,msg,channel,sender = select(1,...)
	--if sender == UnitName("player") then return end
	--print(ID,msg)
	if ID == ID_SHIELD then
		SGI_DATA.lock[sender] = "SHIELD"
		SGI_QUEUE[sender] = nil
		SGI_ANTI_SPAM[sender] = nil
		print("|cffffff00The player: |r|cff22ff11"..sender.."|r|cffffff00 is protected by |r|cffff8800Guild|r|cff00A2FFShield|r")
	elseif ID == ID_LOCK then
		if not SGI_DATA.lock[sender] then
			SGI_DATA.lock[sender] = "SHARED"
		end
		SGI_QUEUE[sender] = nil
		print("|cffffff00Recieved shared lock on |r|cff22ff11"..msg.."|r|cffffff00 from |r|cff0044ee"..sender.."|r|cffffff00 ("..strlower(channel)..")|r")
	elseif ID == ID_REQUEST then
		BroadcastVersion()
		print("|cffffff00Recieved request of locksharing from |r|cff0033ff"..sender.."|r")
		SendLocks(sender)
	elseif ID == ID_MASSLOCK then
		print("|cffffff00 Recieved: "..RecievedLocks(msg).." new locks from |r|cff0033ff"..sender.."|r")
	elseif ID == ID_VERSION then
		local new = tonumber(msg)
		if new and new > tonumber(VERSION_MAJOR) then
			print("|cffffff00A new version (|r|cff00A2FF"..new.."|r|cffffff00) of |r|cff16ABB5SuperGuildInvite|r|cffffff00 is available at curse.com!")
		end
	end
end

function SGI_EVENTS:CHAT_MSG_SYSTEM(self,event,...)
	local msg,sender = select(1,...)
	if strfind(msg," is declining all") then
		local name = strsub(msg,1,strfind(msg," is declining")-1)
		if not SGI_DATA.lock[name] then
			SGI_DATA.lock[name] = "DECLINING"
		end
	elseif strfind(msg," to join your guild.") and whisperWaiting then
		whisperWaiting = false
		local name = strsub(msg,strfind(msg," invited ")+9,strfind(msg," to join your guild.")-1)
		SendChatMessage(FormatWhisper(SGI_DATA[DATA_INDEX].settings.whisper,name),"WHISPER",nil,name)
		--print("Simulated whisper")
	end
end

CreateFrame("Frame","SGI_EventHandler")
for k,_ in pairs(SGI_EVENTS) do	
	SGI_EventHandler:RegisterEvent(k)
end
SGI_EventHandler:SetScript("OnEvent",function(self,event,...)
	SGI_EVENTS[event](self,event,...)
end)

-- User Interface --

local function CreateNewButton(name,parent,width,height,label,anchor,OnClick)
	local f = CreateFrame("Button",name,parent,"UIPanelButtonTemplate")
	f:SetWidth(width)
	f:SetHeight(height)
	local Label = f:CreateFontString(name.."Font","OVERLAY","GameFontNormalSmall")
	Label:SetText(label)
	Label:SetPoint("CENTER")
	
	if type(anchor) == "table" then
		f:SetPoint(anchor.point,parent,anchor.relativePoint,anchor.xOfs,anchor.yOfs)
	end
	f:SetScript("OnClick",OnClick)
	return f
end

local function CreateNewCheckbox(name,parent,label,anchor)
	local f = CreateFrame("CheckButton",name,parent,"OptionsBaseCheckButtonTemplate")
	local l = f:CreateFontString(name.."Font","OVERLAY","GameFontNormal")
	l:SetText(label)
	l:SetPoint("LEFT",f,"RIGHT",5,1)
	if type(anchor) == "table" then
		f:SetPoint(anchor.point,parent,anchor.relativePoint,anchor.xOfs,anchor.yOfs)
	end
	f:HookScript("OnClick",function(self)
		SGI_DATA[DATA_INDEX].settings.checkboxes[name] = self:GetChecked()
	end)
	if SGI_DATA[DATA_INDEX].settings.checkboxes[name] then
		f:SetChecked()
	end
	return f
end

local function CreateDropDown(Parent,NAME,anchor,ITEMS,name,label)
	local Drop = CreateFrame("Button", NAME, Parent, "UIDropDownMenuTemplate")

	Drop:ClearAllPoints()
	Drop:SetPoint(anchor.point,Parent,anchor.relativePoint,anchor.xOfs,anchor.yOfs)
	Drop:Show()
	
	local Label = Drop:CreateFontString(nil,"OVERLAY","GameFontNormal")
	Label:SetPoint("BOTTOMLEFT",Drop,"TOPLEFT",20,5)
	Label:SetText(label or "")

	local items = {
	"All",
	"Deathknight",
	"Druid",
	"Hunter",
	"Paladin",
	"Mage",
	"Priest",
	"Rogue",
	"Shaman",
	"Warlock",
	"Warrior",
	}
	items = ITEMS or items
	name = name or "Class"
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(Drop, self:GetID())
		SGI_DATA[DATA_INDEX].settings.dropdown[name] = self:GetID()
	end
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(items) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end

	UIDropDownMenu_Initialize(Drop, initialize)
	UIDropDownMenu_SetWidth(Drop, 100);
	UIDropDownMenu_SetButtonWidth(Drop, 124)
	UIDropDownMenu_SetSelectedID(Drop, SGI_DATA[DATA_INDEX].settings.dropdown[name] or 1)
	UIDropDownMenu_JustifyText(Drop, "LEFT")
end



local function CreateInviteListFrame()
	CreateFrame("Frame","SGI_Invites")
	SGI_Invites:SetWidth(300)
	SGI_Invites:SetHeight(20*CountTable(SGI_QUEUE) + 40)
	SGI_Invites:SetMovable()
	SetFramePos(SGI_Invites)
	SGI_Invites:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	SGI_Invites:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		GetFramePos(SGI_Invites)
	end)
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	SGI_Invites:SetBackdrop(backdrop)
	
	SGI_Invites.text = SGI_Invites:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Invites.text:SetPoint("TOP",SGI_Invites,"TOP",-15,-15)
	SGI_Invites.text:SetText("Click on the players you wish to invite")
	SGI_Invites.tooltip = CreateFrame("Frame","InviteTime",SGI_Invites,"GameTooltipTemplate")
	SGI_Invites.tooltip.text = SGI_Invites.tooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Invites.tooltip:SetPoint("TOP",SGI_Invites,"BOTTOM",0,-2)
	SGI_Invites.tooltip.text:SetText("Unknown")
	SGI_Invites.tooltip.text:SetPoint("CENTER")
	
	local close = CreateFrame("Button",nil,SGI_Invites,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",SGI_Invites,"TOPRIGHT",-4,-4)
	
	SGI_Invites:SetScript("OnShow",StartSuperScan)
	SGI_Invites:SetScript("OnHide",StopSuperScan)
	SGI_Invites.items = {}
	local update = 0
	local toolUpdate = 0
	SGI_Invites:SetScript("OnUpdate",function()
		if GetTime() < update then return end
		for k,_ in pairs(SGI_Invites.items) do
			SGI_Invites.items[k]:Hide()
		end
		local i = 0
		local x,y = 10,-30
		for i = 1,30 do
			if not SGI_Invites.items[i] then
				SGI_Invites.items[i] = CreateFrame("Button","InviteBar"..i,SGI_Invites)
				SGI_Invites.items[i]:SetWidth(280)
				SGI_Invites.items[i]:SetHeight(20)
				SGI_Invites.items[i]:EnableMouse(true)
				SGI_Invites.items[i]:SetPoint("TOP",SGI_Invites,"TOP",0,y)
				SGI_Invites.items[i].text = SGI_Invites.items[i]:CreateFontString(nil,"OVERLAY","GameFontNormal")
				SGI_Invites.items[i].text:SetPoint("LEFT",SGI_Invites.items[i],"LEFT",3,0)
				SGI_Invites.items[i].text:SetJustifyH("LEFT")
				SGI_Invites.items[i].player = "unknown"
				SGI_Invites.items[i]:RegisterForClicks("LeftButtonDown","RightButtonDown")
				SGI_Invites.items[i]:SetScript("OnClick",SendGuildInvite)
				
				SGI_Invites.items[i].highlight = SGI_Invites.items[i]:CreateTexture()
				SGI_Invites.items[i].highlight:SetAllPoints()
				SGI_Invites.items[i].highlight:SetTexture(1,1,0,0.2)
				SGI_Invites.items[i].highlight:Hide()
				
				SGI_Invites.items[i]:SetScript("OnEnter",function()
					SGI_Invites.items[i].highlight:Show()
					SGI_Invites.tooltip:Show()
					SGI_Invites.items[i]:SetScript("OnUpdate",function()
						if GetTime() > toolUpdate and SGI_QUEUE[SGI_Invites.items[i].player] then
							SGI_Invites.tooltip.text:SetText("Found |cff"..GetClassColor(SGI_QUEUE[SGI_Invites.items[i].player].classFile)..SGI_Invites.items[i].player.."|r "..FormatTime(floor(GetTime()-SGI_QUEUE[SGI_Invites.items[i].player].found)).." ago")
							local h,w = SGI_Invites.tooltip.text:GetHeight(),SGI_Invites.tooltip.text:GetWidth()
							SGI_Invites.tooltip:SetWidth(w+20)
							SGI_Invites.tooltip:SetHeight(h+20)
							toolUpdate = GetTime() + 0.1
						end
					end)
				end)
				SGI_Invites.items[i]:SetScript("OnLeave",function() 
					SGI_Invites.items[i].highlight:Hide()
					SGI_Invites.tooltip:Hide()
					SGI_Invites.items[i]:SetScript("OnUpdate",nil)
				end)
			end
			y = y - 20
		end
		i = 0
		for k,_ in pairs(SGI_QUEUE) do
			i = i + 1
			local level,classFile,race,class,found = SGI_QUEUE[k].level, SGI_QUEUE[k].classFile, SGI_QUEUE[k].race, SGI_QUEUE[k].class, SGI_QUEUE[k].found
			local Text = i..". |cff"..GetClassColor(classFile)..k.."|r Lvl "..level.." "..race.." |cff"..GetClassColor(classFile)..class.."|r"
			SGI_Invites.items[i].text:SetText(Text)
			SGI_Invites.items[i].player = k
			SGI_Invites.items[i]:Show()
			if i >= 30 then break end
		end
		SGI_Invites:SetHeight(i * 20 + 40)
		update = GetTime() + 0.5
	end)
end

local function ShowSGI_Inv()
	if SGI_Invites then
		SGI_Invites:Show()
	else
		CreateInviteListFrame()
		SGI_Invites:Show()
	end
end

local function HideSGI_Inv()
	if SGI_Invites then
		SGI_Invites:Hide()
	end
end


local function StopSuperScan2()
	SuperScanFrameTimer:SetScript("OnUpdate",nil)
	ScanInProgress = false
	if SuperScanFrame then
		SuperScanFrame:Hide()
	end
	if SGI_Options then
		SGI_Options:Show()
	end
	print("|cffffff00SuperScan was stopped.|r")
end

local function CreateSuperscanFrame()
	CreateFrame("Frame","SuperScanFrame")
	SuperScanFrame:SetWidth(270)
	SuperScanFrame:SetHeight(75)
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	SetFramePos(SuperScanFrame)
	SuperScanFrame:SetMovable()
	SuperScanFrame:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	SuperScanFrame:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		GetFramePos(self)
	end)
	SuperScanFrame:SetBackdrop(backdrop)
	
	SuperScanFrame.time = SuperScanFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SuperScanFrame.time:SetPoint("CENTER",0,15)
	SuperScanFrame.time:SetText("HH:MM:SS")
	
	local anchor = {
		point = "BOTTOMLEFT",
		relativePoint = "BOTTOMLEFT",
		xOfs = 7,
		yOfs = 10,
	}
	
	SuperScanFrame.progress = CreateFrame("Button","SGI_Progress",SuperScanFrame)
	SuperScanFrame.progress:SetWidth(270)
	SuperScanFrame.progress:SetHeight(30)
	SuperScanFrame.progress:SetBackdrop(backdrop)
	SuperScanFrame.progress:SetPoint("TOP",SuperScanFrame,"BOTTOM",0,0)
	
	SuperScanFrame.progress.percent = SuperScanFrame.progress:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SuperScanFrame.progress.percent:SetPoint("CENTER")
	SuperScanFrame.progress.percent:SetText("N/A")
	SuperScanFrame.progress.percent:SetTextColor(0,1,0)
	
	SuperScanFrame.progress.texture = SuperScanFrame.progress:CreateTexture()
	SuperScanFrame.progress.texture:SetPoint("LEFT",5,0)
	SuperScanFrame.progress.texture:SetHeight(19)
	SuperScanFrame.progress.texture:SetWidth(1)
	SuperScanFrame.progress.texture:SetTexture(1,0.5,0,0.4)
	
	SuperScanFrame.progress.tooltip = CreateFrame("Frame","progressTooltip",SuperScanFrame.progress,"GameTooltipTemplate")
	SuperScanFrame.progress.tooltip:SetWidth(120)
	SuperScanFrame.progress.tooltip:SetHeight(40)
	SuperScanFrame.progress.tooltip:SetPoint("TOP",SuperScanFrame.progress,"BOTTOM")
	SuperScanFrame.progress.tooltip.text = SuperScanFrame.progress.tooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SuperScanFrame.progress.tooltip.text:SetPoint("LEFT",SuperScanFrame.progress.tooltip,"LEFT",10,0)
	SuperScanFrame.progress.tooltip.text:SetJustifyH("LEFT")
	SuperScanFrame.progress.tooltip.text:SetText("Click to toggle SuperScan")
	SuperScanFrame.progress.tooltip.text:SetWidth(110)
	SuperScanFrame.progress:SetScript("OnEnter",function()
		SuperScanFrame.progress.tooltip:Show()
	end)
	SuperScanFrame.progress:SetScript("OnLeave",function()
		SuperScanFrame.progress.tooltip:Hide()
	end)
	SuperScanFrame.progress:SetScript("OnClick",function()
		if ScanInProgress then
			StopSuperScan2()
		else
			StartSuperScan()
		end
	end)
	local update = 0
	SuperScanFrame.progress:SetScript("OnUpdate",function(self)
		if GetTime() > update then
			local num
			if whoQueryList then
				num = #whoQueryList
			else
				num = 10000
			end
			local percent = (SuperScanProgress-1)/num
			if percent < 0.01 then percent = 1/260 end
			--self.texture:SetWidth(ceil(percent*260))
			--self.percent:SetText(floor(100*percent).."%")
			if SuperScanFrame.timeV and SuperScanFrame.timeS and SuperScanFrame.timeT then
				local diff = GetTime() - SuperScanFrame.timeS
				
				SuperScanFrame.time:SetText(FormatTime(SuperScanFrame.timeV-diff).." remaining")
				local total,diff2 = (#whoQueryList -1) * SuperScanInterval,GetTime() - SuperScanFrame.timeT
				local cent = diff2/total
				if cent > 1 then cent = 1 end
				self.texture:SetWidth(ceil(cent*260))
				self.percent:SetText(floor(100 * cent).."%")
			end
			SGI_InviteButtonFont:SetText("Invite: "..CountTable(SGI_QUEUE))
			update = GetTime() + 0.5
		end
	end)
	
	SuperScanFrame.button1 = CreateNewButton("SGI_PurgeQueue",SuperScanFrame,85,25,"Purge Queue",anchor,function() SGI_QUEUE = {} end)
	anchor.xOfs = 92
	SuperScanFrame.button2 = CreateNewButton("SGI_InviteButton",SuperScanFrame,85,25,"Invite: "..CountTable(SGI_QUEUE),anchor,SendGuildInvite)
	anchor.xOfs = 177
	SuperScanFrame.button3 = CreateNewButton("SGI_ChooseInviteButton",SuperScanFrame,85,25,"Choose Invites",anchor,ShowSGI_Inv)
	
end

local function ShowSuperScan()
	if SuperScanFrame then
		SuperScanFrame:Show()
	else
		CreateSuperscanFrame()
		SuperScanFrame:Show()
	end
end

local function HideSuperScan()
	if SuperScanFrame then
		SuperScanFrame:Hide()
	end
end



local function StartSuperScan()
	CreateScanQuery(SGI_DATA[DATA_INDEX].settings.lowLimit,SGI_DATA[DATA_INDEX].settings.highLimit,SGI_DATA[DATA_INDEX].settings.interval,SGI_DATA[DATA_INDEX].settings.raceStart,SGI_DATA[DATA_INDEX].settings.classStart)
	SuperScanFrameTimer:SetScript("OnUpdate",SuperScan)
	ScanInProgress = true
	SuperScanProgress = 1
	if SuperScanFrame then
		SuperScanFrame:Show()
		SuperScanFrame.timeT = GetTime()
	else
		CreateSuperscanFrame()
		SuperScanFrame:Show()
		SuperScanFrame.timeT = GetTime()
	end
	print("|cffffff00SuperScan was started.|r")
end
local function StopSuperScan()
	SuperScanFrameTimer:SetScript("OnUpdate",nil)
	ScanInProgress = false
	if SuperScanFrame then
		SuperScanFrame:Hide()
	end
	if SGI_Options then
		SGI_Options:Show()
	end
	print("|cffffff00SuperScan was stopped.|r")
end













local function CreateWhisperDefineFrame()
	CreateFrame("Frame","SGI_Whisper")
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	SGI_Whisper:SetWidth(500)
	SGI_Whisper:SetHeight(365)
	SGI_Whisper:SetBackdrop(backdrop)
	SetFramePos(SGI_Whisper)
	SGI_Whisper:SetMovable()
	SGI_Whisper:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	SGI_Whisper:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		GetFramePos(SGI_Whisper)
	end)
	
	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	SGI_Whisper.title = SGI_Whisper:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Whisper.title:SetText("SuperGuildInvite Custom Whisper")
	SGI_Whisper.title:SetPoint("TOP",SGI_Whisper,"TOP",0,-20)
	
	SGI_Whisper.info = SGI_Whisper:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Whisper.info:SetPoint("TOPLEFT",SGI_Whisper,"TOPLEFT",33,-55)
	SGI_Whisper.info:SetText("Create a customized whisper to send people you invite! If you enter the words (must be caps) |cff00ff00NAME|r, |cff0000ffLEVEL|r or |cffff0000PLAYER|r these will be replaced by your |cff00ff00Guildname|r, |cff0000ffGuildlevel|r and |cffff0000the recieving players name|r.")
	SGI_Whisper.info:SetWidth(450)
	SGI_Whisper.info:SetJustifyH("LEFT")
	
	SGI_Whisper.edit = CreateFrame("EditBox",nil,SGI_Whisper)
	SGI_Whisper.edit:SetWidth(450)
	SGI_Whisper.edit:SetHeight(65)
	SGI_Whisper.edit:SetMultiLine(true)
	SGI_Whisper.edit:SetPoint("TOPLEFT",SGI_Whisper,"TOPLEFT",35,-140)
	SGI_Whisper.edit:SetFontObject("GameFontNormal")
	SGI_Whisper.edit:SetTextInsets(10,10,10,10)
	SGI_Whisper.edit:SetMaxLetters(256)
	SGI_Whisper.edit:SetBackdrop(backdrop)
	SGI_Whisper.edit:SetText(SGI_DATA[DATA_INDEX].settings.whisper)
	SGI_Whisper.edit:SetScript("OnHide",function()
		SGI_Whisper.edit:SetText(SGI_DATA[DATA_INDEX].settings.whisper)
	end)
	SGI_Whisper.edit.text = SGI_Whisper.edit:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Whisper.edit.text:SetPoint("TOPLEFT",SGI_Whisper.edit,"TOPLEFT",10,13)
	SGI_Whisper.edit.text:SetText("Enter you whisper")
	
	anchor = {}
		anchor.point = "BOTTOMLEFT"
		anchor.relativePoint = "BOTTOMLEFT"
		anchor.xOfs = 100
		anchor.yOfs = 20
	
	CreateNewButton("SGI_SAVEWHISPER",SGI_Whisper,120,30,"Save",anchor,function()
		local text = SGI_Whisper.edit:GetText()
		SGI_DATA[DATA_INDEX].settings.whisper = text
		SendChatMessage(FormatWhisper(text,UnitName("player")),"WHISPER",nil,UnitName("Player"))
		SGI_Whisper:Hide()
	end)
	anchor.xOfs = 280
	CreateNewButton("SGI_CANCELWHISPER",SGI_Whisper,120,30,"Cancel",anchor,function()
		f:Hide()
	end)
end

local function ShowWhisperFrame()
	if SGI_Whisper then
		SGI_Whisper:Show()
	else
		CreateWhisperDefineFrame()
		SGI_Whisper:Show()
	end
end

local function HideWhisperFrame()
	if SGI_Whisper then
		SGI_Whisper:Hide()
	end
end

local function CreateOptions()
	CreateFrame("Frame","SGI_Options")
	SGI_Options:SetWidth(550)
	SGI_Options:SetHeight(350)
	SetFramePos(SGI_Options)
	SGI_Options:SetMovable()
	SGI_Options:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	SGI_Options:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		GetFramePos(SGI_Options)
	end)
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	SGI_Options:SetBackdrop(backdrop)
	local close = CreateFrame("Button",nil,SGI_Options,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",SGI_Options,"TOPRIGHT",-4,-4)
	
	SGI_Options.title = SGI_Options:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.title:SetText("SuperGuildInvite "..VERSION_MAJOR..VERSION_MINOR.." Options")
	SGI_Options.title:SetPoint("TOP",SGI_Options,"TOP",0,-15)
	SGI_Options.bottom = SGI_Options:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.bottom:SetText("Written by Janniie - Stormreaver EU")
	SGI_Options.bottom:SetPoint("BOTTOM",SGI_Options,"BOTTOM",0,20)
	
	local anchor = {}
			anchor.point = "TOPLEFT"
			anchor.relativePoint = "TOPLEFT"
			anchor.xOfs = 20
			anchor.yOfs = -50
	
	local WhisperMode = {
		"Only invite",
		"Invite and whisper",
		"Only whisper",
	}
	--SGI_Options.checkbox1 = CreateNewCheckbox("SGI_ENABLED",SGI_Options,"SGI enabled",anchor)
		--anchor.yOfs = anchor.yOfs - 30
	SGI_Options.checkbox2 = CreateNewCheckbox("SGI_WHISPER",SGI_Options,"Send a whisper before inviting",anchor)
		anchor.yOfs = anchor.yOfs - 50
	SGI_Options.dropdown1 = CreateDropDown(SGI_Options,"SGI_WHISPER_MODE",anchor,WhisperMode,"SGI_WHISPER_MODE","Whisper Type")
		anchor.yOfs = anchor.yOfs - 30
	SGI_Options.checkbox3 = CreateNewCheckbox("SGI_MUTE",SGI_Options,"Mute SGI",anchor)
		anchor.yOfs = anchor.yOfs - 30
	SGI_Options.checkbox4 = CreateNewCheckbox("SGI_RACE",SGI_Options,"Define the first use of race search",anchor)
		anchor.yOfs = anchor.yOfs - 30
	SGI_Options.checkbox5 = CreateNewCheckbox("SGI_CLASS",SGI_Options,"Define the first use of class search",anchor)
	
		anchor.point = "BOTTOMLEFT"
		anchor.relativePoint = "BOTTOMLEFT"
		anchor.xOfs = 20
		anchor.yOfs = 45
		
	SGI_Options.button1 = CreateNewButton("SGI_CUSTOM_WHISPER",SGI_Options,120,30,"Customize Whisper",anchor,ShowWhisperFrame)
		anchor.xOfs = anchor.xOfs + 125
	SGI_Options.button2 = CreateNewButton("SGI_SUPERSCAN",SGI_Options,120,30,"SuperScan",anchor,function()
		if ScanInProgress then
			StopSuperScan()
		else
			StartSuperScan()
			SGI_Options:Hide()
		end
	end)
		anchor.xOfs = anchor.xOfs + 125
	SGI_Options.button3 = CreateNewButton("SGI_INVITE",SGI_Options,120,30,"Invite: "..CountTable(SGI_QUEUE),anchor,SendGuildInvite)
		anchor.xOfs = anchor.xOfs + 125
	SGI_Options.button4 = CreateNewButton("SGI_CHOOSE",SGI_Options,120,30,"Choose Invites",anchor,ShowSGI_Inv)
		anchor.yOfs = 80
	--SGI_Options.button5 = CreateNewButton("SGI_ADV_FIL",SGI_Options,120,30,"Advanced Filtering",anchor)
		anchor.xOfs = anchor.xOfs - 125
	--SGI_Options.button6 = CreateNewButton("SGI_HELP",SGI_Options,120,30,"Help",anchor)
	
	SGI_Options.limitLow = CreateFrame("Frame","SGI_LowLimit",SGI_Options)
	SGI_Options.limitLow:SetWidth(40)
	SGI_Options.limitLow:SetHeight(40)
	SGI_Options.limitLow:SetPoint("CENTER",SGI_Options,"CENTER",20,80)
	SGI_Options.limitLow.text = SGI_Options.limitLow:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.limitLow.text:SetPoint("CENTER")
	SGI_Options.limitLow.texture = SGI_Options.limitLow:CreateTexture()
	SGI_Options.limitLow.texture:SetAllPoints()
	SGI_Options.limitLow.texture:SetTexture(1,1,0,0.2)
	SGI_Options.limitLow.texture:Hide()
	SGI_Options.limitTooltip = CreateFrame("Frame","LimitTool",SGI_Options.limitLow,"GameTooltipTemplate")
	SGI_Options.limitTooltip:SetWidth(120)
	SGI_Options.limitTooltip:SetHeight(40)
	SGI_Options.limitTooltip:SetPoint("TOP",SGI_Options.limitLow,"BOTTOM")
	SGI_Options.limitTooltip.text = SGI_Options.limitTooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.limitTooltip.text:SetPoint("LEFT",SGI_Options.limitTooltip,"LEFT",10,0)
	SGI_Options.limitTooltip.text:SetJustifyH("LEFT")
	SGI_Options.limitTooltip.text:SetText("Scroll to change")
	SGI_Options.limitTooltip.text:SetWidth(110)
	
	SGI_Options.limitLow:SetScript("OnEnter",function()
		SGI_Options.limitLow.texture:Show()
		SGI_Options.limitTooltip:Show()
	end)
	SGI_Options.limitLow:SetScript("OnLeave",function()
		SGI_Options.limitLow.texture:Hide()
		SGI_Options.limitTooltip:Hide()
	end)
	
	
	SGI_Options.limitHigh = CreateFrame("Frame","SGI_HighLimit",SGI_Options)
	SGI_Options.limitHigh:SetWidth(40)
	SGI_Options.limitHigh:SetHeight(40)
	SGI_Options.limitHigh:SetPoint("CENTER",SGI_Options,"CENTER",60,80)
	SGI_Options.limitHigh.text = SGI_Options.limitHigh:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.limitHigh.text:SetPoint("CENTER")
	SGI_Options.limitHigh.texture = SGI_Options.limitHigh:CreateTexture()
	SGI_Options.limitHigh.texture:SetAllPoints()
	SGI_Options.limitHigh.texture:SetTexture(1,1,0,0.2)
	SGI_Options.limitHigh.texture:Hide()
	
	SGI_Options.limitHigh:SetScript("OnEnter",function()
		SGI_Options.limitHigh.texture:Show()
		SGI_Options.limitTooltip:Show()
	end)
	SGI_Options.limitHigh:SetScript("OnLeave",function()
		SGI_Options.limitHigh.texture:Hide()
		SGI_Options.limitTooltip:Hide()
	end)
	
	SGI_Options.limitLow.text:SetText(SGI_DATA[DATA_INDEX].settings.lowLimit.."  - ")
	SGI_Options.limitLow:SetScript("OnMouseWheel",function(self,delta)
		if delta == 1 and SGI_DATA[DATA_INDEX].settings.lowLimit + 1 <= SGI_DATA[DATA_INDEX].settings.highLimit then
			SGI_DATA[DATA_INDEX].settings.lowLimit = SGI_DATA[DATA_INDEX].settings.lowLimit + 1
			SGI_Options.limitLow.text:SetText(SGI_DATA[DATA_INDEX].settings.lowLimit.." - ")
		elseif delta == -1 and SGI_DATA[DATA_INDEX].settings.lowLimit - 1 > 0 then
			SGI_DATA[DATA_INDEX].settings.lowLimit = SGI_DATA[DATA_INDEX].settings.lowLimit - 1
			SGI_Options.limitLow.text:SetText(SGI_DATA[DATA_INDEX].settings.lowLimit.." - ")
		end
	end)
	
	SGI_Options.limitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.highLimit)
	SGI_Options.limitHigh:SetScript("OnMouseWheel",function(self,delta)
		if delta == 1 and SGI_DATA[DATA_INDEX].settings.highLimit + 1 <= 90 then
			SGI_DATA[DATA_INDEX].settings.highLimit = SGI_DATA[DATA_INDEX].settings.highLimit + 1
			SGI_Options.limitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.highLimit)
		elseif delta == -1 and SGI_DATA[DATA_INDEX].settings.highLimit > SGI_DATA[DATA_INDEX].settings.lowLimit then
			SGI_DATA[DATA_INDEX].settings.highLimit = SGI_DATA[DATA_INDEX].settings.highLimit - 1
			SGI_Options.limitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.highLimit)
		end
	end)
	
	SGI_Options.limitText = SGI_Options.limitLow:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.limitText:SetPoint("BOTTOM",SGI_Options.limitLow,"TOP",16,3)
	SGI_Options.limitText:SetText("Level limits:")
	
	
	SGI_Options.raceLimitHigh = CreateFrame("Frame","SGI_RaceLimitHigh",SGI_Options)
	SGI_Options.raceLimitHigh:SetWidth(40)
	SGI_Options.raceLimitHigh:SetHeight(40)
	SGI_Options.raceLimitHigh:SetPoint("CENTER",SGI_Options,"CENTER",150,80)
	SGI_Options.raceLimitHigh.text = SGI_Options.raceLimitHigh:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.raceLimitHigh.text:SetPoint("CENTER")
	SGI_Options.raceLimitHigh.texture = SGI_Options.raceLimitHigh:CreateTexture()
	SGI_Options.raceLimitHigh.texture:SetAllPoints()
	SGI_Options.raceLimitHigh.texture:SetTexture(1,1,0,0.2)
	SGI_Options.raceLimitHigh.texture:Hide()
	SGI_Options.raceTooltip = CreateFrame("Frame","LimitTool",SGI_Options.raceLimitHigh,"GameTooltipTemplate")
	SGI_Options.raceTooltip:SetWidth(120)
	SGI_Options.raceTooltip:SetHeight(40)
	SGI_Options.raceTooltip:SetPoint("TOP",SGI_Options.raceLimitHigh,"BOTTOM")
	SGI_Options.raceTooltip.text = SGI_Options.raceTooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.raceTooltip.text:SetPoint("LEFT",SGI_Options.raceTooltip,"LEFT",10,0)
	SGI_Options.raceTooltip.text:SetJustifyH("LEFT")
	SGI_Options.raceTooltip.text:SetText("Scroll to change")
	SGI_Options.raceTooltip.text:SetWidth(110)
	
	SGI_Options.raceLimitText = SGI_Options.raceLimitHigh:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.raceLimitText:SetPoint("BOTTOM",SGI_Options.raceLimitHigh,"TOP",0,3)
	SGI_Options.raceLimitText:SetText("Racefilter Start:")
	
	SGI_Options.raceLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.raceStart)
	SGI_Options.raceLimitHigh:SetScript("OnMouseWheel",function(self,delta)
		if delta == -1 and SGI_DATA[DATA_INDEX].settings.raceStart > 1 then
			SGI_DATA[DATA_INDEX].settings.raceStart = SGI_DATA[DATA_INDEX].settings.raceStart - 1
			SGI_Options.raceLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.raceStart)
		elseif delta == 1 and SGI_DATA[DATA_INDEX].settings.raceStart < 90 then
			SGI_DATA[DATA_INDEX].settings.raceStart = SGI_DATA[DATA_INDEX].settings.raceStart + 1
			SGI_Options.raceLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.raceStart)
		end
	end)
	
	SGI_Options.raceLimitHigh:SetScript("OnEnter",function()
		SGI_Options.raceLimitHigh.texture:Show()
		SGI_Options.raceTooltip:Show()
	end)
	SGI_Options.raceLimitHigh:SetScript("OnLeave",function()
		SGI_Options.raceLimitHigh.texture:Hide()
		SGI_Options.raceTooltip:Hide()
	end)
	
	SGI_Options.classLimitHigh = CreateFrame("Frame","SGI_ClassLimitHigh",SGI_Options)
	SGI_Options.classLimitHigh:SetWidth(40)
	SGI_Options.classLimitHigh:SetHeight(40)
	SGI_Options.classLimitHigh:SetPoint("CENTER",SGI_Options,"CENTER",150,10)
	SGI_Options.classLimitHigh.text = SGI_Options.classLimitHigh:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.classLimitHigh.text:SetPoint("CENTER")
	SGI_Options.classLimitHigh.texture = SGI_Options.classLimitHigh:CreateTexture()
	SGI_Options.classLimitHigh.texture:SetAllPoints()
	SGI_Options.classLimitHigh.texture:SetTexture(1,1,0,0.2)
	SGI_Options.classLimitHigh.texture:Hide()
	SGI_Options.classTooltip = CreateFrame("Frame","LimitTool",SGI_Options.classLimitHigh,"GameTooltipTemplate")
	SGI_Options.classTooltip:SetWidth(120)
	SGI_Options.classTooltip:SetHeight(40)
	SGI_Options.classTooltip:SetPoint("TOP",SGI_Options.classLimitHigh,"BOTTOM")
	SGI_Options.classTooltip.text = SGI_Options.classTooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.classTooltip.text:SetPoint("LEFT",SGI_Options.classTooltip,"LEFT",10,0)
	SGI_Options.classTooltip.text:SetJustifyH("LEFT")
	SGI_Options.classTooltip.text:SetText("Scroll to change")
	SGI_Options.classTooltip.text:SetWidth(110)
	
	SGI_Options.classLimitText = SGI_Options.classLimitHigh:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.classLimitText:SetPoint("BOTTOM",SGI_Options.classLimitHigh,"TOP",0,3)
	SGI_Options.classLimitText:SetText("Classfilter Start:")
	
	SGI_Options.classLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.classStart)
	SGI_Options.classLimitHigh:SetScript("OnMouseWheel",function(self,delta)
		if delta == -1 and SGI_DATA[DATA_INDEX].settings.classStart > 1 then
			SGI_DATA[DATA_INDEX].settings.classStart = SGI_DATA[DATA_INDEX].settings.classStart - 1
			SGI_Options.classLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.classStart)
		elseif delta == 1 and SGI_DATA[DATA_INDEX].settings.classStart < 90 then
			SGI_DATA[DATA_INDEX].settings.classStart = SGI_DATA[DATA_INDEX].settings.classStart + 1
			SGI_Options.classLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.classStart)
		end
	end)
	
	SGI_Options.classLimitHigh:SetScript("OnEnter",function()
		SGI_Options.classLimitHigh.texture:Show()
		SGI_Options.classTooltip:Show()
	end)
	SGI_Options.classLimitHigh:SetScript("OnLeave",function()
		SGI_Options.classLimitHigh.texture:Hide()
		SGI_Options.classTooltip:Hide()
	end)
	
	SGI_Options.Interval = CreateFrame("Frame","SGI_Interval",SGI_Options)
	SGI_Options.Interval:SetWidth(40)
	SGI_Options.Interval:SetHeight(40)
	SGI_Options.Interval:SetPoint("CENTER",SGI_Options,"CENTER",40,10)
	SGI_Options.Interval.text = SGI_Options.Interval:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	SGI_Options.Interval.text:SetPoint("CENTER")
	SGI_Options.Interval.texture = SGI_Options.Interval:CreateTexture()
	SGI_Options.Interval.texture:SetAllPoints()
	SGI_Options.Interval.texture:SetTexture(1,1,0,0.2)
	SGI_Options.Interval.texture:Hide()
	SGI_Options.intervalTooltip = CreateFrame("Frame","LimitTool",SGI_Options.Interval,"GameTooltipTemplate")
	SGI_Options.intervalTooltip:SetWidth(120)
	SGI_Options.intervalTooltip:SetHeight(40)
	SGI_Options.intervalTooltip:SetPoint("TOP",SGI_Options.Interval,"BOTTOM")
	SGI_Options.intervalTooltip.text = SGI_Options.intervalTooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.intervalTooltip.text:SetPoint("LEFT",SGI_Options.intervalTooltip,"LEFT",10,0)
	SGI_Options.intervalTooltip.text:SetJustifyH("LEFT")
	SGI_Options.intervalTooltip.text:SetText("Scroll to change")
	SGI_Options.intervalTooltip.text:SetWidth(110)
	
	SGI_Options.intervalText = SGI_Options.Interval:CreateFontString(nil,"OVERLAY","GameFontNormal")
	SGI_Options.intervalText:SetPoint("BOTTOM",SGI_Options.Interval,"TOP",0,3)
	SGI_Options.intervalText:SetText("Interval:")
	
	SGI_Options.Interval.text:SetText(SGI_DATA[DATA_INDEX].settings.interval)
	SGI_Options.Interval:SetScript("OnMouseWheel",function(self,delta)
		if delta == -1 and SGI_DATA[DATA_INDEX].settings.interval > 1 then
			SGI_DATA[DATA_INDEX].settings.interval = SGI_DATA[DATA_INDEX].settings.interval - 1
			SGI_Options.Interval.text:SetText(SGI_DATA[DATA_INDEX].settings.interval)
		elseif delta == 1 and SGI_DATA[DATA_INDEX].settings.interval < 30 then
			SGI_DATA[DATA_INDEX].settings.interval = SGI_DATA[DATA_INDEX].settings.interval + 1
			SGI_Options.Interval.text:SetText(SGI_DATA[DATA_INDEX].settings.interval)
		end
	end)
	
	SGI_Options.Interval:SetScript("OnEnter",function()
		SGI_Options.Interval.texture:Show()
		SGI_Options.intervalTooltip:Show()
	end)
	SGI_Options.Interval:SetScript("OnLeave",function()
		SGI_Options.Interval.texture:Hide()
		SGI_Options.intervalTooltip:Hide()
	end)
	
	local SGI_OptionsUpdate = 0
	SGI_Options:SetScript("OnUpdate",function()
		if SGI_OptionsUpdate < GetTime() then
			
			if SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_CLASS"] and not SGI_ClassLimitHigh:IsShown() then
				SGI_ClassLimitHigh:Show()
				SGI_DATA[DATA_INDEX].settings.classStart = 90
				SGI_Options.classLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.classStart)
			elseif not SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_CLASS"] then
				SGI_ClassLimitHigh:Hide()
				SGI_DATA[DATA_INDEX].settings.classStart = 91
			end
			if SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_RACE"] and not SGI_RaceLimitHigh:IsShown() then
				SGI_RaceLimitHigh:Show()
				SGI_DATA[DATA_INDEX].settings.raceStart = 90
				SGI_Options.raceLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.raceStart)
			elseif not SGI_DATA[DATA_INDEX].settings.checkboxes["SGI_RACE"] then
				SGI_RaceLimitHigh:Hide()
				SGI_DATA[DATA_INDEX].settings.raceStart = 91
			end
			
			SGI_INVITEFont:SetText("Invite: "..CountTable(SGI_QUEUE))
			SGI_Options.Interval.text:SetText(SGI_DATA[DATA_INDEX].settings.interval)
			SGI_Options.classLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.classStart)
			SGI_Options.raceLimitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.raceStart)
			
			SGI_Options.limitLow.text:SetText(SGI_DATA[DATA_INDEX].settings.lowLimit.." - ")
			SGI_Options.limitHigh.text:SetText(SGI_DATA[DATA_INDEX].settings.highLimit)
			
			SGI_OptionsUpdate = GetTime() + 0.5
			
		end
	end)
end

local function ShowOptions()
	if SGI_Options then
		SGI_Options:Show()
	else
		CreateOptions()
		SGI_Options:Show()
	end
end

local function HideOptions()
	if SGI_Options then
		SGI_Options:Hide()
	end
end

local function CreateMinimapbutton()
	local f = CreateFrame("Button","SGI_MiniMapButton",Minimap)
	f:SetWidth(32)
	f:SetHeight(32)
	f:SetFrameStrata("MEDIUM")
	f:SetMovable(true)
	SetFramePos(f)
	
	f:SetNormalTexture("Interface\\AddOns\\SuperGuildInvite\\SGI_MiniMapButton")
	f:SetPushedTexture("Interface\\AddOns\\SuperGuildInvite\\SGI_MiniMapButtonPushed")
	f:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	
	local tooltip = CreateFrame("Frame","SGI_TooltTipMini",f,"GameTooltipTemplate")
	tooltip:SetPoint("BOTTOMRIGHT",f,"TOPLEFT",0,-3)
	local toolstring = tooltip:CreateFontString(nil,"OVERLAY","GameFontNormal")
	toolstring:SetPoint("CENTER")
	toolstring:SetText(LOGO.."|cff88aaffSuperGuildInvite|r")
	tooltip:SetWidth(toolstring:GetWidth()+ 20)
	tooltip:SetHeight(30)
	tooltip:Hide()
	f:SetScript("OnEnter",function()
		tooltip:Show()
	end)
	f:SetScript("OnLeave",function()
		tooltip:Hide()
	end)
	
	local function moveButton(self)
		local centerX, centerY = Minimap:GetCenter()
		local x, y = GetCursorPosition()
		x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
		centerX, centerY = math.abs(x), math.abs(y)
		centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 78, (centerY / sqrt(centerX^2 + centerY^2)) * 78
		centerX = x < 0 and -centerX or centerX
		centerY = y < 0 and -centerY or centerY
		self:ClearAllPoints()
		self:SetPoint("CENTER", centerX, centerY)
	end
	
	f:SetScript("OnMouseDown",function(self,button)
		if button == "RightButton" then
			self:SetScript("OnUpdate",moveButton)
		end
	end)
	f:SetScript("OnMouseUp",function(self,button)
		self:SetScript("OnUpdate",nil)
		GetFramePos(self)
	end)
	f:SetScript("OnClick",function(self,button)
		if SGI_Options and SGI_Options:IsShown() then
			HideOptions()
		else
			ShowOptions()
		end
	end)
end

MinimapLoad = function() if not SGI_MiniMapButton then CreateMinimapbutton() end end

function SlashCmdList.SUPERGUILDINVITE(msg)
	if msg == "reset" then
		local lock = SGI_DATA.lock
		SGI_DATA = nil
		SGI_EVENTS["PLAYER_LOGIN"]()
		SGI_DATA.lock = lock
	elseif msg == "locks" then
		DisplayLocks()
	elseif strfind(msg,"unlock") then
		local name = strsub(msg,8)
		if SGI_DATA.lock[name] == "MANUAL" then
			SGI_DATA.lock[name] = nil
			print("|cffffff00Manual lock removed on |r|cff00A2FF"..name.."|r")
		elseif SGI_DATA.lock[name] then
			print("|cffffff00The lock on |r|cff00A2FF"..name.."|r|cffffff00 is not manual and can't be removed.|r")
		else
			print("|cffffff00There is no lock on |r|cff00A2FF"..name.."|r")
		end
	elseif strfind(msg,"lock") then
		local name = strsub(msg,6)
		if name then
			SGI_DATA.lock[name] = "MANUAL"
		end
		print("|cffffff00Manual lock on: |r|cff00A2FF"..name.."|r")
	elseif strfind(msg,"limit") then
		local low,high = strsplit(":",strsub(msg,6))
		high = tonumber(high)
		low = tonumber(low)
		if high > 90 then high = 90 end
		if high < low then print("|cffffff00Format: /sgi limit low:high|r") return end
		if low < 1 then low = 1 end
		if low > 90 then low = high-1 end
		SGI_DATA[DATA_INDEX].settings.lowLimit = low
		SGI_DATA[DATA_INDEX].settings.highLimit = high
		print("|cffffff00New low: "..low.." New High: "..high.."|r")
	elseif strfind(msg,"class") then
		local class = tonumber(strsub(msg,7))
		if class then
			if class < 1 then
				class = 1
			elseif class > 90 then
				class = 90
			end
		end
		SGI_DATA[DATA_INDEX].settings.classStart = class
		print("|cffffff00Class searching now starts on level |r|cff00A2FF"..class)
	elseif strfind(msg,"race") then
		local race = tonumber(strsub(msg,6))
		if class then
			if class < 1 then
				class = 1
			elseif class > 90 then
				class = 90
			end
		end
		SGI_DATA[DATA_INDEX].settings.raceStart = race
		print("|cffffff00Race searching now starts on level |r|cff00A2FF"..race)
	elseif strfind(msg,"interval") then
		local interval = tonumber(strsub(msg,10))
		if interval then
			if interval < 1 then
				interval = 1
			elseif interval > 85 then
				interval = 85
			end
		end
		SGI_DATA[DATA_INDEX].settings.interval = interval
		print("|cffffff00Search interval changed to |r|cff00A2FF"..interval)
	elseif msg == "options" then
		ShowOptions()
	elseif msg == "show" then
		for k,_ in pairs(whoQueryList) do
			print(whoQueryList[k])
		end
	else
		print("|cffffff00Commands: |r|cff00A2FF/sgi or /superguildinvite|r")
		print("|cff00A2FFreset |r|cffffff00to reset all data except locks|r")
		print("|cff00A2FFlocks |r|cffffff00to display currently locked players|r")
		print("|cff00A2FFlock <player>|r|cffffff00 will lock the specified player|r")
		print("|cff00A2FFunlock <player>|r|cffffff00 will unlock the specified player IF they were added manually|r")
		print("|cff00A2FFlimit low:high|r|cffffff00 changes the search limits to low and high|r")
		print("|cff00A2FFclass level|r|cffffff00 changes the level at which class searching will start|r")
		print("|cff00A2FFrace level|r|cffffff00 changes the level at which race searching will start|r")
		print("|cff00A2FFinterval number|r|cffffff00 changes the range each search will have (5 means 1-5,6-10 and so on)|r")
		print("|cff00A2FFoptions|r|cffffff00 shows the options. Same effect as clicking the minimap button|r")
		
	end
end